-- This does exactly the same thing as the key program that comes with
-- Euphoria does, but using ESE. Although this program is more complicated
-- using ESE, more complex programs will probably be a lot simpler using ESE.
-- I have also added more complexity than is nessicary to demonstrate all
-- the features of ESE.
without warning -- I don't use some stuff in this example, but that's OK
include ese.e -- Include ESE
-- Define the events
constant KEY_EVENT = AddEvent()     -- Define an event for when a key is pressed
constant QUIT_EVENT = AddEvent()    -- Define an event for when q is pressed
procedure KeyboardEventGenerator()  -- The keyboard event generator
    integer key
    key = get_key()
    if key != -1 then
	FireEvent(KEY_EVENT,{key})  -- Fire the event with one argument, key
    end if
end procedure
procedure onKeyEvent(integer key)   -- When a key event occurs...
    printf(1,"The key code is: %d\n",key) -- Display the key code
end procedure
procedure checkForQuit(integer key) -- Check for whether the user has pressed q
    if key = 'q' then
	FireEvent(QUIT_EVENT,{})    -- Fire the quit event, no arguments
    end if
end procedure
procedure onQuitEvent()             -- When a quit event occurs
    StopEventLoop()                 -- Stop the loop
end procedure
-- Add the keyboard event generator
constant KEYEVENT_GENERATOR = AddEventGenerator(routine_id("KeyboardEventGenerator"))
-- Add the key event handler (to display the key code)
constant ONKEYEVENT = AddEventHandler(KEY_EVENT,routine_id("onKeyEvent"))
-- Add the key event handler (to check for 'q')
constant CHECKFORQUIT = AddEventHandler(KEY_EVENT,routine_id("checkForQuit"))
-- Add the quit event handler
constant ONQUITEVENT = AddEventHandler(QUIT_EVENT,routine_id("onQuitEvent"))
-- Make it look like the original program
puts(1,"Press any key. I'll show you the key code. Press q to quit\n\n")
StartEventLoop() -- Process the events
